Subject: [bug#33008] [WIP] openjdk 9 and 10

From: Julien Lepiller <[email-masked]>
Date: Thu, 18 Oct 2018 16:06:02 +0200

Le 2018-10-18 13:57, Björn Höfling a écrit :
> On Wed, 10 Oct 2018 23:40:59 +0200
> Julien Lepiller <[email-masked]> wrote:
> 
>> Hi, here are two patches that add openjdk9 and openjdk10. The patches
>> must be applied on top of core-updates (or master once core-updates is
>> merged) because of an issue with gcc on master. I haven't tested them
>> too much, and they were probably too easy to build, so I wouldn't be
>> surprised if we found something bad in them.
> 
> Hi Julien,
> 
> thanks for caring about JDK! I'm positively surprised that it works
> without any Icedtea-efford. The package definition doesn't look too
> complicated and it doesn't take too much time to build. And, no, I
> haven't found something awfully "bad" in there :-)
> 
> I could even play with the module system and build my own mini-JRE with
> only the core modules. I wonder if this new feature of JDK9 would be
> useful in Guix one day.
> 
> It builds reproducibly, besides from the docs. Maybe we can fix
> that with the newest Icedtea patch from Gabor? I haven't yet looked
> into that patch.
> 
> Version:
> (version "9+181")
> 
> Where does that "+181" come from? When I look here:
> 
> https://jdk.java.net/archive/
> 
> I find 9.0.1 and 9.0.4. But maybe that's the versioning of the
> precompiled releases?

This page says the binary comes from the tag jdk-9.0.4+12, but there
is no such tag in the repository here:

https://hg.openjdk.java.net/jdk9/jdk9/tags

But maybe I'm not looking at the right place?

> 
> Also, the "+" is not very user-friendly:
> 
> ./pre-inst-env guix build openjdk@9
> guix build: error: openjdk: package not found for version 9
> 
> Whereas for icedtea I'm used to say: guix build icedtea@1
> 
> When I temporarily change that to "9.181" it works. I think there was
> some functionality within the "@"-logic that matches versions modulo
> dots. You get what I mean?

Ok, I'll change the version number to 9.181.

> 
> Also, as I don't know where the version comes from, I couldn't check
> weather this one is the latest or not.

It's the latest tag in the list and I don't expect any new release now.

> 
> [] Binaries included? If yes, created a snipped?
> find . -name "*.rar" -or -name "*.pdf" -or -name "*.bin" -or -name
> "*.pdf" -or -name "*.dsy" -or -name "*.jar" -or -name "*.exe"
> 
> There is one exe, many test jars. Two test bins,
> and two jars in the main:
> 
> find hotspot/src/ -name "*.jar"
> hotspot/src/share/tools/IdealGraphVisualizer/branding/modules/org-netbeans-core-windows.jar
> hotspot/src/share/tools/IdealGraphVisualizer/branding/core/core.jar
> 
> But that looks like being part of some tool anyway.
> 
> Can you strip some/all away? I haven't investigated further. As we are
> currently not running any tests, stripping away the test jars should be
> fine.

I'll try that, thanks for noticing :)

> 
> Is there a reason you removed this phase:
>            (delete 'patch-source-shebangs)
> 
> Homepage: Use HTTPS
> Donload-URL: Use HTTPS
> 
> License: I think you missed the classpath thing, cmp. IcedTea:
> 
> ;; IcedTea is released under the GPL2 + Classpath exception, which is 
> the
> ;; same license as both GNU Classpath and OpenJDK.
> 
> When I check with licencechecker there are some files under BSD-3:
> 
> nashorn/samples/*
> jdk/make/netbeans/*
> jdk/src/demo/*
> test/fmw/gest/include/gtest/internal/*
> 
> though I'm not sure if they are relevant, as they all are in "test" or
> "make" or "demo".
> 
> Björn